Subject: Re: bug#12853: 24.2.50; doc of `color-defined-p'

From: Eli Zaretskii <[email-masked]>
Date: Sat, 10 Nov 2012 21:17:52 +0200

> From: "Drew Adams" <[email-masked]>
> Cc: <[email-masked]>
> Date: Sat, 10 Nov 2012 10:56:04 -0800
> 
> I'm asking that the doc be corrected and made more clear and
> complete.

Fine with me.  I didn't want to imply that the doc string should not
be corrected.  I just wanted to explain why unspecified-* "colors" are
exceptions, and why they are mentioned in the doc string.

> In any case, please make clear here just what is meant by a "defined color" in
> this context

This is already part of the doc string:

  Return non-nil if color COLOR is supported on frame FRAME.
                          ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

"Supported" means you can use COLOR in any context where a color is
expected, and the display will show that color without signaling an
error.

> and how that definition relates to those particular noncolor
> defined-color exceptions.

This would require to delve too deep into the internals, which might
not be appropriate for a doc string.

> IOW, if the meaning of "defined color" here were straightforward and we could
> simply point to some other function (e.g. `defined-colors'), then doing that
> would be appropriate and sufficient to make clear what that term means here.
> Since the meaning is NOT obvious or straightforward, it needs to be provided
> (explained).

I don't understand why you are looking for a definition, beyond the
simple one stated in the doc string, when the function we are talking
about, color-defined-p, provides that definition: a "defined color"
for the purposes of this function is something for which this function
returns a non-nil value.